<?php
error_reporting(E_ALL);
/**
 * Database configuration
 */
 

	
	
require_once('config/db_config.php');

define('DBTYPE',    'mysql');
define('DBUSER',    USER_NAME);
define('DBPASS',    PASSWORD);
define('DBHOST',    HOST_NAME);
define('DBNAME',    DATABASE_NAME);
define('DBDSN',     DBTYPE.':'.'host='.DBHOST.';dbname='.DBNAME);
define('DBDSNEZ',   DBTYPE.'://'.DBUSER.':'.DBPASS.'@'.DBHOST.'/'.DBNAME);

define('ENCRYPT_SALT',      'saltisgood');

/**
 * Load constants and functions
 */

require_once('config/config.php');


/**
 * Load libraries
 */
require('vendor/autoload.php');                       // composer library
require_once 'lib/beaconApi.php';                   	// application
require_once 'lib/beaconApiResponse.php';           	// api response object
require_once 'lib/beaconApiResponseMeta.php';       	// api response meta object
require_once 'lib/Helpers/RedBeanHelper.php';         // RedBean helper
require_once 'lib/Helpers/ArrayHelper.php';           // array helper
require_once 'lib/Helpers/PasswordHelper.php';        // password helper
require_once 'lib/Helpers/ResponseHelper.php';           // array helper
require_once 'lib/Enumerations/AccountType.php';      // user type enumeration
require_once 'lib/Enumerations/StatusType.php';      	// status type enumeration
require_once 'lib/Enumerations/ErrorCodeType.php';    // error code type enumeration
require_once 'lib/Enumerations/HttpStatusCode.php';   // http status code
require_once 'lib/Exceptions/ApiException.php';       // http exceptions

/**
 * Library objects
 */
use RedBean_Facade as R;
use Helpers\RedBeanHelper as RedBeanHelper;
use Helpers\PasswordHelper as PasswordHelper;
use Enumerations\HttpStatusCode as HttpStatusCode;
use Exceptions\ApiException as ApiException;
use Enumerations\AccountType as AccountType;
use Enumerations\StatusType as StatusType;
use Enumerations\ErrorCodeType as ErrorCodeType;


?>