<?php

/**
 * Description of Model_Beacons
 *
 * @author
 */
use RedBean_Facade as R;
use Helpers\PasswordHelper as PasswordHelper;
use Enumerations\HttpStatusCode as HttpStatusCode;
use Enumerations\AccountType as AccountType;
use Enumerations\StatusType as StatusType;
use Enumerations\ErrorCodeType as ErrorCodeType;
use Exceptions\ApiException as ApiException;
use Valitron\Validator as Validator;
use Helpers\RedBeanHelper as RedBeanHelper;
//Require needed models

class Model_Beacons extends RedBean_SimpleModel {
    /**
     * Constructor
     */
    public function __construct() {

    }

    /**
	* @param get beacon list
	*/
	public function getBeaconList(){
		$returnArray = array();
		 /**
         * Get the bean
         * @var $bean Model_Beacons
         */
		
		/* START - variable declarations */
		$latitude			= $longitude		= $deviceIds 	 = '';
		$iBeaconStoreCond 	= $iBeaconOrderby = $iBeaconfields = '';
		$virtualStoreCond 	= $virtualOrderby = $virtualfields = '';
		$distanceCondition	= '';
		$uuidStoreCond		= '';
		$storeOwner			= $organizationId	=	0;
		$beaconList 		= $beaconListArray	 =  $beaconMajorArray = array();
		$virtualBeacons		= $virtualBeaconArray = $virtualListArray  = array();
		$devicesArray		= $majorArray	= $orgImgArray = $orgSkinArray = $vorgImgArray = $vorgSkinArray  = array();
		/* END - variable declarations */
		
		
        $bean 				= $this->bean;
		$language			= $bean->Language;
		$latitude			= $bean->Latitude;
		$longitude			= $bean->Longitude;
		$userId				= $bean->UserId;
		$start				= $bean->Start != '' ? $bean->Start : 0;
		if(isset($bean->Store) && $bean->Store != '')
			$storeOwner		= $bean->Store;
		
		//Start: New beacon list with new filters - 24/03/2018
		$UUID				= $bean->UUID;
		$major				= $bean->Major;
		//End: New beacon list with new filters - 24/03/2018
		//Start: New beacon list with new filters - 30/03/2019
		$minor				= $bean->Minor;
		//Start: New beacon list with new filters - 30/03/2019
		/* START - handle condition for store owner login */
		if($storeOwner == 1){
			if($userId != ''){
				$iBeaconStoreCond	=	" and b.fkUsersId = ".$userId." ";
				$virtualStoreCond	=	" and b.fkUsersId = ".$userId." ";
				
				$userSql			=	"select fkOrganizationId from users where id = ".$userId;
				$organizationResult	=	R::getAll($userSql);
				if($organizationResult) {
					$organizationId	=	$organizationResult[0]['fkOrganizationId'];
				}
				if($organizationId != 0)
					$uuidStoreCond	=	"and d.fkOrganizationId = ".$organizationId;
				else
					$uuidStoreCond		=	" and d.fkUsersId = ".$userId." ";
			}
		}else if($storeOwner == 2){
			if($userId != ''){
				$sql	=	" select id from organizations where fkAdminsId = ".$userId."  ";
				$organizationDetails	=	R::getAll($sql);
				if($organizationDetails){
					$organizationId	=	$organizationDetails[0]['id'];
				}
				if($organizationId != 0){
					$iBeaconStoreCond	=	" and b.fkOrganizationId = ".$organizationId." ";
					$virtualStoreCond	=	" and b.fkOrganizationId = ".$organizationId." ";
					$uuidStoreCond		=	" and d.fkOrganizationId = ".$organizationId." ";
				}else{
					$iBeaconStoreCond	=	" and b.fkAdminsId = ".$userId." ";
					$virtualStoreCond	=	" and b.fkAdminsId = ".$userId." ";
					$uuidStoreCond		=	" and d.fkAdminsId = ".$userId." ";
				}
			}
		}
		/* END - handle condition for store owner login */
		
		/* START - iBeacon Listing */
		
		$iBeaconOrderby			=	"d.id desc";
		$majorOrderby			=	"";
		if(!empty($latitude) && !empty($longitude)){
			$iBeaconfields	 	= ",(((acos(sin((".$latitude."*pi()/180)) * sin((b.`Latitude`*pi()/180))+cos((".$latitude."*pi()/180)) * cos((b.`Latitude`*pi()/180)) * cos(((".$longitude." - b.`Longitude`)*pi()/180))))*180/pi())*60*1.1515)*1.6093 as Distance";
		}
		if($storeOwner == 0){
			if(!empty($latitude) && !empty($longitude)){
				$iBeaconOrderby		=	"Distance asc";
				$majorOrderby		=	" order by Distance asc";
				$distanceCondition	=	" Having Distance <= 1 ";
			}
		}
		//Start: New beacon list with filter
		$uuidCondition	=	$majorCondition =$minorCondition =  "";	
		if(!empty($UUID)){
			$uuidCondition	=	" and d.DeviceId = '".$UUID."' ";	
		}
		if(!empty($major)){
			$majorCondition	=	" and b.Major = ".$major;	
		}
		if(!empty($minor)){
			$minorCondition	=	" and b.Minor = ".$minor;	
		}
		//End: New beacon list with filter
		
		$sql		=	"select DISTINCT d.id,b.fkOrganizationId  ".$iBeaconfields." from devices as d 
						left join beacons as b on(b.fkDevicesId = d.id)
						where b.Latitude != '' and b.Longitude != '' and b.Status = 1 and b.BeaconType != 2 and d.Status = 1 ".$iBeaconStoreCond." ".$uuidCondition." ".$majorCondition." ".$minorCondition." ".$distanceCondition." order by ".$iBeaconOrderby." limit 0,18";
		
		
		$devices	= 	R::getAll($sql);
		if(!empty($devices)){
			foreach($devices as $dkey=>$dval){
				$devicesArray[]	=	$dval['id'];
				$orgArray[]		=	$dval['fkOrganizationId'];
			}
			if(!empty($devicesArray)){
				$deviceIds	=	implode(array_unique($devicesArray),',');
			}
		}
		if(!empty($orgArray)){
			$orgIds		=	implode(array_unique($orgArray),',');
			$sql		=	" select id,OrganizationImage,SkinColor from organizations where id IN (".$orgIds.")  ";
			$orgData	=	R::getAll($sql);
			if(!empty($orgData)){
				foreach($orgData as $skey=>$sval){
					$OriginalImagePath 	  = ADMIN_IMAGE_PATH.'organization_default.png';
					$OrganizationImagePath = '';
					$OrganizationImageName 		= 	$sval['OrganizationImage'];
					if($OrganizationImageName != ''){
						if(SERVER){
							if(image_exists(6,$OrganizationImageName))
								$OriginalImagePath 		= 	ORGANIZATION_IMAGE_PATH.$OrganizationImageName;
							if(image_exists(7,$OrganizationImageName))
								$OrganizationImagePath	= 	ORGANIZATION_THUMB_IMAGE_PATH.$OrganizationImageName;
						}
						else{
							if(file_exists(ORGANIZATION_IMAGE_PATH_REL.$OrganizationImageName)){
								$OriginalImagePath 		= 	ORGANIZATION_IMAGE_PATH.$OrganizationImageName;
							}if(file_exists(ORGANIZATION_THUMB_IMAGE_PATH_REL.$OrganizationImageName)){
								$OrganizationImagePath	= 	ORGANIZATION_THUMB_IMAGE_PATH.$OrganizationImageName;
							}
						}
					}
					if($sval['SkinColor'] != '')
						$SkinColor = $sval['SkinColor'];
					else
						$SkinColor = '#208E59';
					$orgImgArray[$sval['id']] 	= $OriginalImagePath;
					$orgSkinArray[$sval['id']] 	= $SkinColor;
				}
			}
		}
		if(!empty($devicesArray)){
			$sql		=	"select DISTINCT b.Major ".$iBeaconfields." from beacons as b
							where b.fkDevicesId IN (".$deviceIds.") and  b.Latitude != '' and b.Longitude != '' and b.BeaconType != 2 and b.Status = 1 ".$iBeaconStoreCond." ".$majorCondition." ".$minorCondition." ".$distanceCondition." ".$majorOrderby." limit 0,18";
						
			$majors	= 	R::getAll($sql);
			if(!empty($majors)){
				foreach($majors as $mkey=>$mval){
					$majorArray[]	=	$mval['Major'];
				}
				if(!empty($majorArray)){
					$majorIds	=	implode(array_unique($majorArray),',');
				}
			}
		}
		if(!empty($devicesArray) && !empty($majorArray)){
			$sql 				= " select b.id as BeaconId,d.id as DevicesId,d.DeviceId as UUID,d.DeviceName,b.fkOrganizationId,
									b.LocationLimit,b.EnableBluetooth,b.IntervalDays,b.Major,b.Minor,b.Description,
									b.StaticMessage,b.DynamicMessage,b.Photo,b.BatteryPower,d.Longitude,d.Latitude,
									b.Longitude as BeaconLongitude,b.Latitude as BeaconLatitude,b.DescriptionFR,b.StaticMessageFR,
									b.DynamicMessageFR,b.Angle1Message,b.Angle1MessageFr,b.Angle2Message,b.Angle2MessageFr,
									b.Angle1WaitMessage,b.Angle1WaitMessageFr,b.Angle1WalkMessage,b.Angle1WalkMessageFr,
									b.Angle2WaitMessage,b.Angle2WaitMessageFr,b.Angle2WalkMessage,b.Angle2WalkMessageFr,b.StreetMode,
									b.Street1NameEnglish,b.Street2NameEnglish,b.Street1NameFrench,b.Street2NameFrench,b.AutomaticChk,b.Alignment,b.WalkMeThere,
									b.Street1Alias1,b.Street2Alias1,b.Street1Alias2,b.Street2Alias2,b.Street1Alias1Fr,b.Street2Alias1Fr,b.Street1Alias2Fr,b.Street2Alias2Fr,
									b.Identifier,ba.id as AngleId,ba.*".$iBeaconfields.",b.BatteryLastUpdated
									from devices as d
									left join users as u on( u.id = d.fkUsersId )
									left join beacons as b on(b.fkDevicesId = d.id)
									left join beaconsangle as ba on(ba.fkBeaconsId = b.id)
									where d.id IN (".$deviceIds.") and b.Major IN (".$majorIds.") and b.BeaconType != 2  
									and  b.Latitude != '' and b.Longitude != '' and d.Status = 1 
									and b.Status = 1 ".$iBeaconStoreCond." ".$uuidCondition." ".$minorCondition." ".$distanceCondition."  order by ".$iBeaconOrderby."  ";
			$beaconList			= R::getAll($sql);
		}
		if($beaconList){
			foreach($beaconList as $key=>$value){
				$beaconImagePath	=	$beaconThumbPath = $descriptionFR = $staticMessageFR = $dynamicMessageFR = $description = $staticMessage = $dynamicMessage = '';
				$beaconMajorArray	=	array();
				$beaconMajorArray[$value['DevicesId']]['UUID']				=	$value['UUID'];
				$beaconMajorArray[$value['DevicesId']]['Name']				=	$value['DeviceName'];
				if($value['Photo'] != ''){
					if(SERVER){
						if(image_exists(4,$value['Photo']))
							$beaconImagePath = BEACON_IMAGE_PATH.$value['Photo'];
						if(image_exists(5,$value['Photo']))
							$beaconThumbPath = BEACON_IMAGE_PATH.$value['Photo'];
					}
					else{
						if(file_exists(BEACON_IMAGE_PATH_REL.$value['Photo']))
							$beaconImagePath = BEACON_IMAGE_PATH.$value['Photo'];
						if(file_exists(BEACON_THUMB_IMAGE_PATH_REL.$value['Photo']))
							$beaconThumbPath = BEACON_THUMB_IMAGE_PATH.$value['Photo'];
					}
				}
				if(isset($value['BeaconId'])){
					$StreetMode		=	(int)$value['StreetMode'];
					$AutomaticChk	=	(int)$value['AutomaticChk'];
					if($StreetMode == 0){
						$AlignmentChk	=	1;
					}
					else{
						$AlignmentChk	=	(int)$value['Alignment'];
					}
					$SkinPath	=	ADMIN_IMAGE_PATH.'organization_default.png';
					$SkinColor  = '#208E59';
					if(isset($orgImgArray[$value['fkOrganizationId']]))
						$SkinPath		=	$orgImgArray[$value['fkOrganizationId']];
					if(isset($orgSkinArray[$value['fkOrganizationId']]))
						$SkinColor		=	$orgSkinArray[$value['fkOrganizationId']];	
					$beaconMajorArray[$value['DevicesId']]['UUID']										= $value['UUID'];
					$beaconMajorArray[$value['DevicesId']]['BeaconName']								= $value['DeviceName'];	
					$beaconMajorArray[$value['DevicesId']]['BeaconId']									= (string)$value['BeaconId'];
					$beaconMajorArray[$value['DevicesId']]['Major']										= (int)$value['Major'];
					$beaconMajorArray[$value['DevicesId']]['Minor']										= (int)$value['Minor'];
					$beaconMajorArray[$value['DevicesId']]['EnableBluetooth']							= (int)$value['EnableBluetooth'];
					$beaconMajorArray[$value['DevicesId']]['IntervalDays']								= (int)$value['IntervalDays'];
					$beaconMajorArray[$value['DevicesId']]['LocationLimit']								= round($value['LocationLimit']);
					$beaconMajorArray[$value['DevicesId']]['Identifier']								= $value['Identifier'];
					$beaconMajorArray[$value['DevicesId']]['StreetMode']								= $StreetMode;
					$beaconMajorArray[$value['DevicesId']]['AutomaticChk']								= (int)$value['AutomaticChk'];
					$beaconMajorArray[$value['DevicesId']]['WalkMeThere']								= (int)$value['WalkMeThere'];
					$beaconMajorArray[$value['DevicesId']]['Alignment']									= $AlignmentChk;
					$beaconMajorArray[$value['DevicesId']]['OrganizationId']							= $value['fkOrganizationId'];
					$beaconMajorArray[$value['DevicesId']]['OrganizationSkin']							= $SkinPath;
					$beaconMajorArray[$value['DevicesId']]['SkinColor']									= $SkinColor;
					if(isset($value['DescriptionFR']))
						$descriptionFR		=	$value['DescriptionFR'];
					if(isset($value['StaticMessageFR']))
						$staticMessageFR	=	$value['StaticMessageFR'];
					if(isset($value['DynamicMessageFR']))
						$dynamicMessageFR	=	$value['DynamicMessageFR'];
					if(isset($value['Description']))
						$description		=	$value['Description'];
					if(isset($value['StaticMessage']))
						$staticMessage		=	$value['StaticMessage'];
					if(isset($value['DynamicMessage']))
						$dynamicMessage		=	$value['DynamicMessage'];
					
					if(isset($value['Angle1WalkMessage']))
						$angle1Message		=	$value['Angle1WalkMessage'];
					if(isset($value['Angle1WalkMessageFr']))
						$angle1MessageFr	=	$value['Angle1WalkMessageFr'];
					if(isset($value['Angle2WalkMessage']))
						$angle2Message		=	$value['Angle2WalkMessage'];
					if(isset($value['Angle2WalkMessageFr']))
						$angle2MessageFr	=	$value['Angle2WalkMessageFr'];
						
					if(isset($value['Angle1WaitMessage']))
						$angle1WaitMessage		=	$value['Angle1WaitMessage'];
					if(isset($value['Angle1WaitMessageFr']))
						$angle1WaitMessageFr	=	$value['Angle1WaitMessageFr'];
					if(isset($value['Angle1WalkMessage']))
						$angle1WalkMessage		=	$value['Angle1WalkMessage'];
					if(isset($value['Angle1WalkMessageFr']))
						$angle1WalkMessageFr	=	$value['Angle1WalkMessageFr'];
					
					if(isset($value['Angle2WaitMessage']))
						$angle2WaitMessage		=	$value['Angle2WaitMessage'];
					if(isset($value['Angle2WaitMessageFr']))
						$angle2WaitMessageFr	=	$value['Angle2WaitMessageFr'];
					if(isset($value['Angle2WalkMessage']))
						$angle2WalkMessage		=	$value['Angle2WalkMessage'];
					if(isset($value['Angle2WalkMessageFr']))
						$angle2WalkMessageFr	=	$value['Angle2WalkMessageFr'];
						
					if(isset($value['Street1NameEnglish']))
						$street1Name	=	$value['Street1NameEnglish'];
					if(isset($value['Street1NameFrench']))
						$street1NameFr	=	$value['Street1NameFrench'];
					if(isset($value['Street2NameEnglish']))
						$street2Name	=	$value['Street2NameEnglish'];
					if(isset($value['Street2NameFrench']))
						$street2NameFr	=	$value['Street2NameFrench'];
					
					if(isset($value['Street1Alias1']))
						$street1Alias1	=	$value['Street1Alias1'];
					if(isset($value['Street2Alias1']))
						$street2Alias1	=	$value['Street2Alias1'];
					if(isset($value['Street1Alias2']))
						$street1Alias2	=	$value['Street1Alias2'];
					if(isset($value['Street2Alias2']))
						$street2Alias2	=	$value['Street2Alias2'];
					if(isset($value['Street1Alias1Fr']))
						$street1Alias1Fr	=	$value['Street1Alias1Fr'];
					if(isset($value['Street2Alias1Fr']))
						$street2Alias1Fr	=	$value['Street2Alias1Fr'];
					if(isset($value['Street1Alias2Fr']))
						$street1Alias2Fr	=	$value['Street1Alias2Fr'];
					if(isset($value['Street2Alias2Fr']))
						$street2Alias2Fr	=	$value['Street2Alias2Fr'];
					
					if($language == 'fr'){
						$beaconMajorArray[$value['DevicesId']]['Description']							= $descriptionFR;
						$beaconMajorArray[$value['DevicesId']]['StaticMessage']							= $staticMessageFR;
						$beaconMajorArray[$value['DevicesId']]['DynamicMessage']						= $dynamicMessageFR;
						$beaconMajorArray[$value['DevicesId']]['Angle1Message']							= $angle1MessageFr;
						$beaconMajorArray[$value['DevicesId']]['Angle2Message']							= $angle2MessageFr;
						$beaconMajorArray[$value['DevicesId']]['Angle1WaitMessage']						= $angle1WaitMessageFr;
						$beaconMajorArray[$value['DevicesId']]['Angle1WalkMessage']						= $angle1WalkMessageFr;
						$beaconMajorArray[$value['DevicesId']]['Angle2WaitMessage']						= $angle2WaitMessageFr;
						$beaconMajorArray[$value['DevicesId']]['Angle2WalkMessage']						= $angle2WalkMessageFr;
						$beaconMajorArray[$value['DevicesId']]['Street1Name']							= $street1NameFr;
						$beaconMajorArray[$value['DevicesId']]['Street2Name']							= $street2NameFr;
						$beaconMajorArray[$value['DevicesId']]['Street1Alias1']							= $street1Alias1Fr;
						$beaconMajorArray[$value['DevicesId']]['Street2Alias1']							= $street2Alias1Fr;
						$beaconMajorArray[$value['DevicesId']]['Street1Alias2']							= $street1Alias2Fr;
						$beaconMajorArray[$value['DevicesId']]['Street2Alias2']							= $street2Alias2Fr;
					}else{
						$beaconMajorArray[$value['DevicesId']]['Description']							= $description;
						$beaconMajorArray[$value['DevicesId']]['StaticMessage']							= $staticMessage;
						$beaconMajorArray[$value['DevicesId']]['DynamicMessage']						= $dynamicMessage;
						$beaconMajorArray[$value['DevicesId']]['Angle1Message']							= $angle1Message;
						$beaconMajorArray[$value['DevicesId']]['Angle2Message']							= $angle2Message;
						$beaconMajorArray[$value['DevicesId']]['Angle1WaitMessage']						= $angle1WaitMessage;
						$beaconMajorArray[$value['DevicesId']]['Angle1WalkMessage']						= $angle1WalkMessage;
						$beaconMajorArray[$value['DevicesId']]['Angle2WaitMessage']						= $angle2WaitMessage;
						$beaconMajorArray[$value['DevicesId']]['Angle2WalkMessage']						= $angle2WalkMessage;
						$beaconMajorArray[$value['DevicesId']]['Street1Name']							= $street1Name;
						$beaconMajorArray[$value['DevicesId']]['Street2Name']							= $street2Name;
						$beaconMajorArray[$value['DevicesId']]['Street1Alias1']							= $street1Alias1;
						$beaconMajorArray[$value['DevicesId']]['Street2Alias1']							= $street2Alias1;
						$beaconMajorArray[$value['DevicesId']]['Street1Alias2']							= $street1Alias2;
						$beaconMajorArray[$value['DevicesId']]['Street2Alias2']							= $street2Alias2;
					}
					$beaconMajorArray[$value['DevicesId']]['OriginalPhoto']								= $beaconImagePath;
					$beaconMajorArray[$value['DevicesId']]['Photo']										= $beaconThumbPath;
					$beaconMajorArray[$value['DevicesId']]['BatteryPower']								= (int)$value['BatteryPower'];
					$beaconMajorArray[$value['DevicesId']]['Latitude']									= $value['BeaconLatitude'];
					$beaconMajorArray[$value['DevicesId']]['Longitude']									= $value['BeaconLongitude'];
					if(isset($value['Distance']))
						$beaconMajorArray[$value['DevicesId']]['Distance']								= $value['Distance'];
					$beaconMajorArray[$value['DevicesId']]['AngleId']									= (int)$value['AngleId'];
					$beaconMajorArray[$value['DevicesId']]['Angles']									= array();
					
					if(!isset($value['Angle1'])	&&	!isset($value['Angle2'])	&&	!isset($value['Angle3'])	&&	!isset($value['Angle4']))	{
						$beaconMajorArray[$value['DevicesId']]['Angles']	= (object)array();
					}
					if(isset($value['Angle1'])){
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle1']['Angle']				= (int)$value['Angle1'];
					}
					if(isset($value['Angle1DescriptionFR']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle1']['Message_Fr']		= $value['Angle1DescriptionFR'];
					if(isset($value['Angle1Description']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle1']['Message_En']		= $value['Angle1Description'];
					if(isset($value['Angle2'])){
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle2']['Angle']				= (int)$value['Angle2'];
					}
					if(isset($value['Angle2DescriptionFR']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle2']['Message_Fr']		= $value['Angle2DescriptionFR'];
					if(isset($value['Angle2Description']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle2']['Message_En']		= $value['Angle2Description'];
					if(isset($value['Angle3']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle3']['Angle']				= (int)$value['Angle3'];
					if(isset($value['Angle3DescriptionFR']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle3']['Message_Fr']		= $value['Angle3DescriptionFR'];
					if(isset($value['Angle3Description']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle3']['Message_En']		= $value['Angle3Description'];
					if(isset($value['Angle4']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle4']['Angle']				= (int)$value['Angle4'];
					if(isset($value['Angle3DescriptionFR']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle4']['Message_Fr']		= $value['Angle4DescriptionFR'];
					if(isset($value['Angle3Description']))
						$beaconMajorArray[$value['DevicesId']]['Angles']['Angle4']['Message_En']		= $value['Angle4Description'];
					if(isset($value['BatteryLastUpdated'])) {
						if($value['BatteryLastUpdated'] == '0000-00-00')
							$beaconMajorArray[$value['DevicesId']]['BatteryLastUpdated']				= '';
						else {
							$date		=	$value['BatteryLastUpdated'];
							$newDate	=	strtotime('+2 Days', strtotime($date));
							$newDate	=	date('Y-m-d',$newDate);
							$beaconMajorArray[$value['DevicesId']]['BatteryLastUpdated']				= $newDate;
						}
					}
					$beaconListArray[]									= $beaconMajorArray[$value['DevicesId']];
				}else{
					$beaconListArray									= $beaconMajorArray;
				}
			}
		}
		/* END - iBeacon Listing */
		
		
		/* START - Virtual Beacons Listing */
		if(!empty($latitude) && !empty($longitude)){
			$virtualOrderby			=	"b.id desc";
			if($storeOwner == 0){
				if(!empty($latitude) && !empty($longitude)){
					$virtualfields	 	= 	",(((acos(sin((".$latitude."*pi()/180)) * sin((b.`Latitude`*pi()/180))+cos((".$latitude."*pi()/180)) * cos((b.`Latitude`*pi()/180)) * cos(((".$longitude." - b.`Longitude`)*pi()/180))))*180/pi())*60*1.1515)*1.6093 as Distance";
					$virtualOrderby		=	"Distance asc,b.id desc";
					$distanceCondition	=	" Having Distance <= 3 ";
				}
			}
			$sql		=	"select DISTINCT b.fkOrganizationId  ".$virtualfields." from beacons as b 
							where b.Latitude != '' and b.Longitude != '' and b.Status = 1 and b.BeaconType = 2 ".$virtualStoreCond." 
							".$distanceCondition." order by ".$virtualOrderby." limit 0,50";
			$devices	= 	R::getAll($sql);
			$vOrgArray  =   array();
			if(!empty($devices)){
				foreach($devices as $dkey=>$dval){
					$vOrgArray[]		=	$dval['fkOrganizationId'];
				}
			}
			if(!empty($vOrgArray)){
				$orgIds		=	implode(array_unique($vOrgArray),',');
				$sql		=	" select id,OrganizationImage,SkinColor from organizations where id IN (".$orgIds.")  ";
				$orgData	=	R::getAll($sql);
				if(!empty($orgData)){
					foreach($orgData as $skey=>$sval){
						$OriginalImagePath 	  = ADMIN_IMAGE_PATH.'organization_default.png';
						$OrganizationImagePath = '';
						$OrganizationImageName 		= 	$sval['OrganizationImage'];
						if($OrganizationImageName != ''){
							if(SERVER){
								if(image_exists(6,$OrganizationImageName))
									$OriginalImagePath 		= 	ORGANIZATION_IMAGE_PATH.$OrganizationImageName;
								if(image_exists(7,$OrganizationImageName))
									$OrganizationImagePath	= 	ORGANIZATION_THUMB_IMAGE_PATH.$OrganizationImageName;
							}
							else{
								if(file_exists(ORGANIZATION_IMAGE_PATH_REL.$OrganizationImageName)){
									$OriginalImagePath 		= 	ORGANIZATION_IMAGE_PATH.$OrganizationImageName;
								}if(file_exists(ORGANIZATION_THUMB_IMAGE_PATH_REL.$OrganizationImageName)){
									$OrganizationImagePath	= 	ORGANIZATION_THUMB_IMAGE_PATH.$OrganizationImageName;
								}
							}
						}
						if($sval['SkinColor'] != '')
							$SkinColor = $sval['SkinColor'];
						else
							$SkinColor = '#208E59';
						$vorgImgArray[$sval['id']] 		= $OriginalImagePath;
						$vorgSkinArray[$sval['id']] 	= $SkinColor;
					}
				}
			}
			$sql			=	"select SQL_CALC_FOUND_ROWS b.id as BeaconId,b.fkOrganizationId,
								b.LocationLimit,b.Description,b.DescriptionFR,b.StaticMessage,b.StaticMessageFR,b.Identifier,
								b.DynamicMessage,b.DynamicMessageFR,b.Photo,b.Longitude,b.Latitude,b.AutomaticChk,b.WalkMeThere,
								ba.id as AngleId,ba.*".$virtualfields.", b.BatteryLastUpdated from beacons as b 
								left join users as u on( u.id = b.fkUsersId )
								left join beaconsangle as ba on(ba.fkBeaconsId = b.id)
								where b.Latitude != '' and b.Longitude != '' and b.BeaconType = 2 and b.Status = 1  ".$virtualStoreCond." 
								".$distanceCondition." order by ".$virtualOrderby." limit ".$start.",100";
			$virtualBeacons	= 	R::getAll($sql);
			$totalRecord 	= 0;
			$totalRec 		=  R::getAll('SELECT FOUND_ROWS() as count');
			if($virtualBeacons){
				$totalRecord = (int)$totalRec[0]['count'];
			}
			$returnArray['TotalVirtualBeacons'] = $totalRecord;
			if($virtualBeacons){
				foreach($virtualBeacons as $skey=>$svalue){
					$virtualImagePath	=	$virtualThumbPath = $descriptionFR = $staticMessageFR = $dynamicMessageFR = $description = $staticMessage = $dynamicMessage = '';
					$virtualBeaconArray	=	array();
					if($svalue['Photo'] != ''){
						if(SERVER){
							if(image_exists(4,$svalue['Photo']))
								$virtualImagePath = BEACON_IMAGE_PATH.$svalue['Photo'];
							if(image_exists(5,$value['Photo']))
								$virtualThumbPath = BEACON_IMAGE_PATH.$svalue['Photo'];
						}
						else{
							if(file_exists(BEACON_IMAGE_PATH_REL.$svalue['Photo']))
								$virtualImagePath = BEACON_IMAGE_PATH.$svalue['Photo'];
							if(file_exists(BEACON_THUMB_IMAGE_PATH_REL.$svalue['Photo']))
								$virtualThumbPath = BEACON_THUMB_IMAGE_PATH.$svalue['Photo'];
						}
					}
					if(isset($svalue['BeaconId'])){
						$virtualBeaconArray[$svalue['BeaconId']]['BeaconId']							= (string)$svalue['BeaconId'];
						$virtualBeaconArray[$svalue['BeaconId']]['LocationLimit']						= round($svalue['LocationLimit']);
						$virtualBeaconArray[$svalue['BeaconId']]['Identifier']							= $svalue['Identifier'];
						$virtualBeaconArray[$svalue['BeaconId']]['fkOrganizationId']					= $svalue['fkOrganizationId'];
						if(isset($svalue['DescriptionFR']))
							$descriptionFR		=	$svalue['DescriptionFR'];
						if(isset($svalue['StaticMessageFR']))
							$staticMessageFR	=	$svalue['StaticMessageFR'];
						if(isset($svalue['DynamicMessageFR']))
							$dynamicMessageFR	=	$svalue['DynamicMessageFR'];
						if(isset($svalue['Description']))
							$description		=	$svalue['Description'];
						if(isset($svalue['StaticMessage']))
							$staticMessage		=	$svalue['StaticMessage'];
						if(isset($svalue['DynamicMessage']))
							$dynamicMessage		=	$svalue['DynamicMessage'];
						if($language == 'fr'){
							$virtualBeaconArray[$svalue['BeaconId']]['Description']						= $descriptionFR;
							$virtualBeaconArray[$svalue['BeaconId']]['StaticMessage']					= $staticMessageFR;
							$virtualBeaconArray[$svalue['BeaconId']]['DynamicMessage']					= $dynamicMessageFR;
						}else{
							$virtualBeaconArray[$svalue['BeaconId']]['Description']						= $description;
							$virtualBeaconArray[$svalue['BeaconId']]['StaticMessage']					= $staticMessage;
							$virtualBeaconArray[$svalue['BeaconId']]['DynamicMessage']					= $dynamicMessage;
						}
						if(isset($svalue['Distance']))
							$virtualBeaconArray[$svalue['BeaconId']]['Distance']						= $svalue['Distance'];
						$virtualBeaconArray[$svalue['BeaconId']]['OriginalPhoto']						= $virtualImagePath;
						$virtualBeaconArray[$svalue['BeaconId']]['Photo']								= $virtualThumbPath;
						$virtualBeaconArray[$svalue['BeaconId']]['Latitude']							= $svalue['Latitude'];
						$virtualBeaconArray[$svalue['BeaconId']]['Longitude']							= $svalue['Longitude'];
						$virtualBeaconArray[$svalue['BeaconId']]['AngleId']								= (int)$svalue['AngleId'];
						$virtualBeaconArray[$svalue['BeaconId']]['WalkMeThere']							= (int)$svalue['WalkMeThere'];
						$virtualBeaconArray[$svalue['BeaconId']]['AutomaticChk']						= (int)$svalue['AutomaticChk'];
						$virtualBeaconArray[$svalue['BeaconId']]['Angles']								= array();
						$SkinPath	=	ADMIN_IMAGE_PATH.'organization_default.png';
						$SkinColor  = '#208E59';
						if(isset($vorgImgArray[$svalue['fkOrganizationId']]))
							$SkinPath		=	$vorgImgArray[$svalue['fkOrganizationId']];
						if(isset($vorgSkinArray[$svalue['fkOrganizationId']]))
							$SkinColor		=	$vorgSkinArray[$svalue['fkOrganizationId']];	
						$virtualBeaconArray[$svalue['BeaconId']]['OrganizationSkin']					= $SkinPath;
						$virtualBeaconArray[$svalue['BeaconId']]['SkinColor']							= $SkinColor;
						if(!isset($svalue['Angle1'])	&&	isset($svalue['Angle2'])	&&	isset($svalue['Angle3'])	&&	isset($svalue['Angle4']))	{
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']							= (object)array();
						}
						
						
						if(isset($svalue['Angle1'])){
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle1']['Angle']		= (int)$svalue['Angle1'];
						}
						if(isset($svalue['Angle1DescriptionFR']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle1']['Message_Fr']	= $svalue['Angle1DescriptionFR'];
						if(isset($svalue['Angle1Description']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle1']['Message_En']	= $svalue['Angle1Description'];
						if(isset($svalue['Angle2'])){
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle2']['Angle']		= (int)$svalue['Angle2'];
						}
						if(isset($svalue['Angle2DescriptionFR']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle2']['Message_Fr']	= $svalue['Angle2DescriptionFR'];
						if(isset($svalue['Angle2Description']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle2']['Message_En']	= $svalue['Angle2Description'];
						if(isset($svalue['Angle3']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle3']['Angle']		= (int)$svalue['Angle3'];
						if(isset($svalue['Angle3DescriptionFR']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle3']['Message_Fr']	= $svalue['Angle3DescriptionFR'];
						if(isset($svalue['Angle3Description']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle3']['Message_En']	= $svalue['Angle3Description'];
						if(isset($svalue['Angle4']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle4']['Angle']		= (int)$svalue['Angle4'];
						if(isset($svalue['Angle3DescriptionFR']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle4']['Message_Fr']	= $svalue['Angle4DescriptionFR'];
						if(isset($svalue['Angle3Description']))
							$virtualBeaconArray[$svalue['BeaconId']]['Angles']['Angle4']['Message_En']	= $svalue['Angle4Description'];
						if(isset($svalue['BatteryLastUpdated'])) {
							if($svalue['BatteryLastUpdated'] == '0000-00-00')
								$virtualBeaconArray[$svalue['BeaconId']]['BatteryLastUpdated']				= '';
							else {
								$date		=	$svalue['BatteryLastUpdated'];
								$newDate	=	strtotime('+2 Days', strtotime($date));
								$newDate	=	date('Y-m-d',$newDate);
								$virtualBeaconArray[$svalue['BeaconId']]['BatteryLastUpdated']				= $newDate;
							}
						}
						$virtualListArray[$svalue['BeaconId']]											= $virtualBeaconArray[$svalue['BeaconId']];
					}else{
						$virtualListArray[$svalue['BeaconId']]											= $virtualBeaconArray;
					}
				}
			}
		}else{
			$returnArray['TotalVirtualBeacons'] = 0;
			$virtualListArray					= array();
		}
		/* END - Virtual Beacons Listing */
		
		/* START - UUID Array */
		$uuidAllArray	= $uuidArray = 	array();
		$sql		=	"select DISTINCT d.DeviceId as UUID ".$iBeaconfields." from devices as d 
						left join major as b on(b.fkDevicesId = d.id)
						where b.Latitude != '' and b.Longitude != '' and d.Status = 1 ".$uuidStoreCond."  order by ".$iBeaconOrderby." ";
		$uuidRes	= 	R::getAll($sql); //group by d.deviceId
		if($uuidRes){
			foreach($uuidRes as $ukey=>$uvalue){
				$uuidAllArray[]	= $uvalue['UUID'];
			}
		}
		$uniqueUUID	= array_unique($uuidAllArray);
		if(isset($uniqueUUID) && !empty($uniqueUUID)){
			$uuidArray 	= array_slice($uniqueUUID, 0, 18); 
		}
		// echo "<pre>=======>";print_r($ui);echo "<=======</pre>";
		/* END - UUID Array */
		
		/* START - Return the result */
		
		$returnArray['BeaconList']['iBeacons']			=	array_values($beaconListArray);
		$returnArray['BeaconList']['virtualBeacons']	=	array_values($virtualListArray);
		$returnArray['BeaconList']['UUID']				=	$uuidArray;
		return $returnArray;
		
		/* END - Return the result */
	}
	
	/**
     * Function to update angles
     * @throws ApiException
     */
	public function updateAngles(){
		/**
         * Get the bean
         * @var $bean Model_Beacons
         */
        $bean 		= $this->bean;
		$this->validateAngles();
		$this->checkAngleExist();
		if($bean->AngleId != ''){
			$angleArray			=	$bean->AngleData;
			$angleArrayJson 	=	json_encode($angleArray);
			$responseInfoJson 	=	json_decode($angleArrayJson,TRUE);
			$angles			=	R::dispense('beaconsangle');
			if(isset($responseInfoJson) && !empty($responseInfoJson)){
				foreach($responseInfoJson as $key=>$val){
					if($key == 0){
						if(isset($val['Angle']))
							$angles->Angle1					=	$val['Angle'];
						if(isset($val['Message_En']))
							$angles->Angle1Description		=	$val['Message_En'];
						if(isset($val['Message_Fr']))
							$angles->Angle1DescriptionFR	=	$val['Message_Fr'];
					}
					if($key == 1){
						if(isset($val['Angle']))
							$angles->Angle2					=	$val['Angle'];
						if(isset($val['Message_En']))
							$angles->Angle2Description		=	$val['Message_En'];
						if(isset($val['Message_Fr']))
							$angles->Angle2DescriptionFR	=	$val['Message_Fr'];
					}
					if($key == 2){
						if(isset($val['Angle']))
							$angles->Angle3					=	$val['Angle'];
						if(isset($val['Message_En']))
							$angles->Angle3Description		=	$val['Message_En'];
						if(isset($val['Message_Fr']))
							$angles->Angle3DescriptionFR	=	$val['Message_Fr'];
					}
					if($key == 3){
						if(isset($val['Angle']))
							$angles->Angle4					=	$val['Angle'];
						if(isset($val['Message_En']))
							$angles->Angle4Description		=	$val['Message_En'];
						if(isset($val['Message_Fr']))
							$angles->Angle4DescriptionFR	=	$val['Message_Fr'];
					}
				}
				$angles->id							=	$bean->AngleId;
				R::store($angles);
				return true;
			}
		}
	}
	 /**
     * Validate the model
     * @throws ApiException if the models fails to validate required fields
     */
    public function validateAngles()
    {
		$bean = $this->bean;
		$rules = [
		            'required' => [
		                ['BeaconId'],['AngleId']
		            ]
		        ];
        $v = new Validator($this->bean);
		
        $v->rules($rules);
        if (!$v->validate()) {
            $errors = $v->errors();
            throw new ApiException("Please check required properties" ,  ErrorCodeType::SomeFieldsRequired, $errors);
        }
    }
	/**
     * Validate the modification of an angle
     * @throws ApiException if the user being modifyng the angle is not the owner.
     */
	public function checkAngleExist()
    {
		$bean 	= $this->bean;
       	$sql	=	'select ba.id as AngleId from beaconsangle as ba
	   			 	left join beacons as b on (b.id = ba.fkBeaconsId)
					where b.Status = 1 and ba.fkBeaconsId = '.$bean->BeaconId.' and ba.id = '.$bean->AngleId.' ';
		$result = R::getAll($sql);// and b.fkUsersId = '.$bean->UserId.'
		if(isset($result) && count($result) >0){
			return true;
		}else{
			throw new ApiException("You don't have access to edit this angle" ,  ErrorCodeType::NoAccessToDoProcess);
		}
    }
	
	/**
     * Add system tracking 
	 * Validation for deviceId
     */
    public function create(){
		 /**
         * Get the bean
         * @var $bean Model_Beacons
         */
        $bean 		= $this->bean;
		
		// validate the model
        $this->validate();
		
		$systemtracking  				= R::dispense('systemtracking');
		$systemtracking->DateCreated 	= date('Y-m-d H:i:s');
		$systemtracking->DateModified 	= $systemtracking->DateCreated;
		$systemtracking->DeviceId 		= $bean->DeviceId;
		$systemtracking->Major 			= $bean->Major;
		$systemtracking->Minor 			= $bean->Minor;
		$systemtracking->MatchAngle 	= $bean->MatchAngle;
		
		//find user id, org id and admin id 
		$sql	=	'SELECT d.fkAdminsId, d.fkOrganizationId, d.fkUsersId, d.DeviceId, d.id as dev, b.fkDevicesId, b.fkAdminsId as adminId, b.fkOrganizationId as orgId, b.fkUsersId as userId, b.Major, b.Minor FROM  `devices` AS d
		LEFT JOIN beacons AS b ON ( b.fkDevicesId = d.id ) 
		WHERE d.DeviceId =  "'.$bean->DeviceId.'" AND b.Major = '.$bean->Major.' AND b.Minor = '.$bean->Minor;
		
		$result = R::getAll($sql);
		$userId = $adminId = $orgId = $deviceId = 0;
		if(isset($result) && count($result) >0){
			$userId		= $result[0]['userId'];
			$adminId 	= $result[0]['adminId'];
			$orgId 		= $result[0]['orgId'];
			$deviceId	= $result[0]['fkDevicesId'];
		}
		$systemtracking->fkAdminsId			=	$adminId;
		$systemtracking->fkOrganizationId	=	$orgId;
		$systemtracking->fkUsersId			=	$userId;
		$systemtracking->fkDevicesId		=	$deviceId;
		
	   // save the bean to the database
		$trackingId 	= R::Store($systemtracking);
	    return $trackingId;
    }

	public function validate(){ // beacon creating
		$bean = $this->bean;
		$rules = [
            'required' => [
                ['DeviceId'],['Major'],['Minor'],['MatchAngle']
            ]
        ];
		$v = new Validator($this->bean);
        $v->rules($rules);
        if (!$v->validate()) {
            $errors = $v->errors();
            throw new ApiException("Please check required properties" ,  ErrorCodeType::SomeFieldsMissing, $errors);
        }
    }
	
	public function updateBatteryPower() { // battery power updating
		$bean	=	$this->bean;
		$this->validateBatteryPower();
		
		$date	=	date('Y-m-d');
		$bean->BatteryLastUpdated	=	$date;
		R::store($this);
		return true;
	}
	
	public function validateBatteryPower() { // validate battery power
		$bean 	= $this->bean;
		$rules	= [
			'required' => [
				['BatteryPower']
			]
		];
		$v	=	new Validator($this->bean);
		$v->rules($rules);
		if (!$v->validate()) {
			$errors	= $v->errors();
			throw new ApiException("Please check required properties", ErrorCodeType::SomeFieldsMissing, $errors);
		}
	}
}
