<?php 
require_once('includes/CommonIncludes.php');
admin_login_check();
commonHead();
require_once('controllers/BeaconController.php');
require_once('controllers/DeviceController.php');
$beaconObj    =   new BeaconController();
$deviceObj	  =	  new DeviceController();
$fieldNameArr = $sampleDataArr = $requiredArr = $explanationArr = array();
if(isset($_GET['cs']) && $_GET['cs'] == 1) {
	unset($_SESSION['beacon_sess_from_date']);
	unset($_SESSION['beacon_sess_to_date']);
	unset($_SESSION['reportId']);
	unset($_SESSION['uuid']);
}

if(isset($_GET['reportId']) && $_GET['reportId'] != '' ){
	$_SESSION['reportId']	=	$_GET['reportId'];
	$field		=	'DeviceId';
	$condition	=	'id = '.$_GET['reportId'];
	$uuidDetail	=	$deviceObj->selectDeviceDetails($field,$condition);
	if(isset($uuidDetail) && is_array($uuidDetail) && count($uuidDetail) > 0) {
		$_SESSION['uuid']	=	$uuidDetail[0]->DeviceId;
	}
}
$deviceId				=	$_SESSION['reportId'];

if(isset($_POST['Search']) && $_POST['Search'] != '') {
	if(isset($_POST['FromDate']) && $_POST['FromDate'] != '') {
		$expiryDate 			= date('Y-m-d',strtotime($_POST['FromDate']));
		$_POST['FromDate'] 		= $expiryDate; 
		$_SESSION['beacon_sess_from_date']	= $_POST['FromDate'];
	}else{
		$_SESSION['beacon_sess_from_date']	=	'';
	}
	if(isset($_POST['ToDate']) && $_POST['ToDate'] != '') {
		$expiryDate 			= date('Y-m-d',strtotime($_POST['ToDate']));
		$_POST['ToDate'] 		= $expiryDate; 
		$_SESSION['beacon_sess_to_date']	= $_POST['ToDate'];
	}else{
		$_SESSION['beacon_sess_to_date']	=	'';
	}
	if(isset($_POST['DeviceId']) && $_POST['DeviceId'] != '')
		$deviceId	=	$_POST['DeviceId'];
}

$condition      	= " fkDevicesId = ".$deviceId;
$field			 	= " *,count(id) as beaconCount ";
$deviceDetails  	= $beaconObj->getBeaconCount($field,$condition);
if(isset($deviceDetails) && is_array($deviceDetails) && count($deviceDetails) > 0) {
	$beaconCount	= 	$deviceDetails[0]->beaconCount;
	// $beaconCount	=	count($deviceDetails);
}
?>
<body class="skin-blue">
	<?php top_header(); ?>
	 <!-- Main content -->
	<section class="content">
		<div class="row">
			<div class="col-md-12 view-page"> 
				<div class="box box-primary box-padding"> 
					<h2>Report Detail <?php if(isset($_SESSION['uuid']) && $_SESSION['uuid'] != '') echo '- '.$_SESSION['uuid']; ?></h2>
					
					<form name="searchCategory" action="ReportDetail" method="post">
						<div class="box box-primary box-padding report separator">
							<div class="box-body no-padding" >
								<div class="col-sm-4 col-xs-12 form-group">
									<label>From Date</label>
									<input type="text" class="form-control show_date" name="FromDate" id="FromDate"  value="<?php if(isset($_SESSION['beacon_sess_from_date']) && $_SESSION['beacon_sess_from_date']!='') echo date('m/d/Y',strtotime($_SESSION['beacon_sess_from_date'])) ?>" >
								</div>
								<div class="col-sm-4 col-xs-12 form-group">
									<label>To Date</label>
									<input type="text" class="form-control show_date" name="ToDate" id="ToDate"  value="<?php if(isset($_SESSION['beacon_sess_to_date']) && $_SESSION['beacon_sess_to_date']!='') echo date('m/d/Y',strtotime($_SESSION['beacon_sess_to_date'])) ?>" >
								</div>
								<input type="hidden" name="DeviceId" value="<?php if(isset($deviceId) && $deviceId != '') echo $deviceId; ?>">
								<div class="col-sm-12 clear" align="center">
									<input type="submit" class="btn btn-success" name="Search" id="Search" value="Search">
								</div>
							</div>
						</div>
					</form>
					
					
					<div class="box-padding">
						<div class="form-group col-sm-12 row">
							<label class=" col-sm-5 col-xs-5 col-md-4">Number Of Beacons Added So Far</label>
							<div  class="col-sm-7 col-xs-7  col-md-8">
								<?php if(isset($beaconCount) && $beaconCount != '') echo $beaconCount; else echo '-'; ?>
							</div>
						</div>	
						<div class="box-footer col-sm-12" align="center">
							<a href="Devices" class="btn btn-default" name="Back" id="Back" title="Back" alt="Back" >Back </a>
						</div>
					</div>
				</div>		
			</div>		
		</div><!-- /.row -->
	</section><!-- /.content -->				
<?php commonFooter(); ?>
</html>
<script type="text/javascript">
	$(".show_date").datepicker({
	showButtonPanel	:	true,        
    buttonText		:	'',
    buttonImageOnly	:	true,
    buttonImage		:	path+'webresources/images/calender.png',
    dateFormat		:	'mm/dd/yy',
	changeMonth		:	true,
	changeYear		:	true,
	hideIfNoPrevNext:	true,
	showWeek		:	true,
	yearRange		:	"c:c+30",
	maxDate			:	"0",
	closeText		:   "Close",
});
$.datepicker._gotoToday = function(id) { 
    $(id).datepicker('setDate', new Date()).datepicker('hide').blur(); 
};
</script>