$(document).ready(function(){

	$.validator.addMethod("nameRegexp", function(value, element) {	
		return this.optional(element) || !(/:|\?|\\|\*|\"|<|>|\||%/g.test(value));
	});
	
	$.validator.addMethod("uuid_format", function(value, element) {	
		var regex 				= 	/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i;
		// var regexBrackets 		= 	/^\{[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}\}$/;
		// return regex.test(value) || regexBrackets.test(value) ;
		return regex.test(value);
	});
	$.validator.addMethod("identifier_format", function(value, element) {
		if($('#Identifier').val() != '') {
			var regex 				= 	/^[0-9A-F]{32}$/i;
			// var regexBrackets 		= 	/^\{[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}\}$/;
			// return regex.test(value) || regexBrackets.test(value) ;
			return regex.test(value);
		} else 
			return true;
	});
	
	$.validator.addMethod("mobile_format", function(value, element) {
		if($('#CellNumber').val() == '')  
			return true;
		else if($('#CellNumber').val().length < 10)  
			return false;
		else
			return true
	});
	
	$.validator.addMethod("non_zero",function(value,element) {
		return this.optional(element) || !(parseFloat(value) == 0);
	});
	
	$.validator.addMethod("battery",function(value,element) {
		return this.optional(element) || !(parseFloat(value)>100);
	});
		
	$.validator.addMethod("organization",function(value,element){
		if($('#Organizations').val == null)
			return true;
		else
			return false;
	});
	
	$.validator.addMethod("greaterThan",function(value,element,param) {
		var otherElement = $(param);
		
		if(otherElement.val() != '' && value != '') {
			return parseInt(value, 10) > parseInt(otherElement.val(), 10);
		} else {
			return true;
		}
	});

	$.validator.addMethod("trafficid_format", function(value, element) {
		var regex			=	/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i;
		return regex.test(value);
	});
	
	$.validator.addMethod("opendoorid_format", function(value, element) {
		var regex			=	/^[0-9A-F]{8}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{4}-[0-9A-F]{12}$/i;
		return regex.test(value);
	});
	$.validator.addMethod("no_space", function(value, element) {
		var regex			=	/[\s]/;
		
		if(regex.test(value) == true){	
			return false; 
		}else{  
			return true;  
		}	
	});
	
//--------------Admin Login----------------Start
$("#admin_login_form").validate({
	rules:{
		user_name		:	{ required:true,no_space:true},
		password		:	{ required:true},
		captcha_code	: 	{ required:{
									depends: function() {
										if($('#captcha_code').length > 0) { return true; }
										else { return false; }
									}
								}
							}
	},
	messages:{
		user_name		:	{ required:'Username is required',no_space:'Please enter valid username' },
		password		:	{ required:'Password is required'},
		captcha_code	:	{ required:'Captcha is required'}
	}

});
//--------------Admin Login----------------End

//--------------User Login----------------Start
$("#user_login_form").validate({
	rules:{
		email			:	{ required:true,email:true },
		password		:	{ required:true}
	},
	messages:{
		email			:	{ required:'Email is required',email:'Please enter a valid email address.' },
		password		:	{ required:'Password is required'}
	}

});
//--------------User Login----------------End

//--------------Forget Password---------------start
$("#forget_password_form").validate({
	rules:{
		email       :	{ required:true,email:true }
         },
	messages:{
		email       :	{ required:'Email address is required',email:'Please enter a valid email address.'}
	}
});
//--------------Forget Password----------------End
//--------------Change Password---------------start
$("#change_password_form").validate({
	rules:{			
		old_password        :	{ required:true},
        new_password     	:   { required:true,minlength:6 },
        confirm_password    :	{ required:true,minlength:6, equalTo:'#new_password'}
	},
	messages:{
		old_password		:	{ required:'Old Password is required' },
		new_password		:	{ required:'New Password is required',minlength:'New Password should have atleast 6 characters'},
		confirm_password    :   { required:'Confirm Password is required',minlength:'Confirm Password should have atleast 6 characters',equalTo:'Password mismatch' }
	}
});
//--------------Change Password----------------End

//--------------General Settings---------------start
$("#general_settings_form").validate({
	rules:{			
		email       		:	{ required:true,email:true },
		empty_admin_logo	:	{ required:false},
		contactEmail		:	{ required:true,email:true },
		phone				:	{ required:true}
	},
	messages:{
		email      			:	{ required:'Email address is required',email:'Please enter a valid email address.'},
		empty_admin_logo	:	{ required:'Admin logo is required'},
		contactEmail		:	{ required:'Contact email is required',email:'Please enter a valid email address.'},
		phone				:	{ required:'Phone is required'}
		
	}
});

//--------------User Settings---------------start
$("#user_settings_form").validate({
	rules:{			
		first_name       	:	{ required:true},
		last_name			:	{ required:true},
		user_email	  		:	{ required:true,email:true },
		// phone				:	{ required:true}
	},
	messages:{
		first_name      	:	{ required:'First name is required'},
		last_name			:	{ required:'Last name is required'},
		user_email			:	{ required:'Email is required', email:'Please enter a valid email address.'},
		// phone				:	{ required:'Phone is required'}
		
	}
});
//--------------User Settings---------------end

$.validator.addMethod("fees_amount", function(value, element) {
	 if($('#fees').val() > 0)  
   		 return true;
	 else
	  	return false
});
//--------------Change Password----------------End

//--------------Add User---------------start
$("#add_device_form").validate({
	rules:{
		DeviceName         	:	{ required:true },
		DeviceId           	:	{ required:true, uuid_format: true },
		Organizations		:	{ required:true },
		//LocationLimit	   	:	{ required:true },
		Status			   	:	{ required:true }
		/* Latitude		   	:	{ required:true },
		Longitude		   	:	{ required:true } */
	},
	messages:{
		DeviceName         	:	{ required:'Name is required' },
		DeviceId       	   	:	{ required:'UUID is required', uuid_format: 'Please enter a valid UUID' },
		Organizations		:	{ required: 'Organization is required' },
		//LocationLimit     :	{ required:'Location limit is required' },
		Status			   	:	{ required:'Status is required' }
		/* Latitude		   	:	{ required:'Latitude is required' },
		Longitude		   	:	{ required:'Longitude is required' }  */
	}
});


//--------------Add user----------------End

//--------------Update User---------------start
$("#update_device_form").validate({
	rules:{
		TrafficIdentifier	:	{ required:true, trafficid_format: true },
		OpendoorIdentifier	:	{ required:true, opendoorid_format: true }
	},	
	messages:{
		TrafficIdentifier	:	{ required:'Traffic Identifier is required',trafficid_format: 'Please enter a valid Traffic Id'},
		OpendoorIdentifier	:	{ required:'Opendoor Identifier is required',opendoorid_format: 'Please enter a valid Opendoor Id'}
	}
});


//--------------Update User---------------End
//--------------Add Location---------------start
$("#add_location_form").validate({
	rules:{
		Interval			:	{ required:true },
		Organizations		:	{ required:true },
		//uuid         		:	{ required:true },
		//Major           	:	{ required:true },
		//Minor        		:	{ required:true },
		BeaconType			:	{ required:true },
		Identifier			:	{ identifier_format:true },
		uuid				: 	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 1) { return true; }
											else { return false; }
										}
									}
								},
		Major				:	{ required:{
										depends: function() {
											if($('#BeaconType').val() != 2) { return true; }
											else { return false; }
										}
									}
								},
		Minor				:	{ required:{
										depends: function() {
											if($('#BeaconType').val() != 2) { return true; }
											else { return false; }
										}
									},
									min : 1,
								},
		Latitude			:	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 2) { return true; }
											else { return false; }
										}
									}
								},
		Longitude			:	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 2) { return true; }
											else { return false; }
										}
									}
								},
		StreetModVal			:	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 3 && $("#StreetMode").is(':checked') &&  $('#Street1Name').val() =='' &&  $('#Street2Name').val() ==''  ) 		{ 
return true; }
											else { return false; }
										}
									}
								},
		Street1Name			:	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 3 && $("#StreetMode").is(':checked') &&  $('#Street1NameFR').val() !=''  ) { return true; }
											else { return false; }
										}
									}
								},
		Street2Name			:	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 3 && $("#StreetMode").is(':checked') &&  $('#Street2NameFR').val() !='' ) { return true; }
											else { return false; }
										}
									}
								},
		Street1NameFR		:	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 3 && $("#StreetMode").is(':checked') && $('#Street1Name').val() !='' ) { return true; }
											else { return false; }
										}
									}
								},
		Street2NameFR		:	{ required:{
										depends: function() {
											if($('#BeaconType').val() == 3 && $("#StreetMode").is(':checked') &&  $('#Street2Name').val() !='') { return true; }
											else { return false; }
										}
									}
								},
		Description			:	{ required:true },
		BatteryPower		:	{ battery:true },
		DescriptionFR		:	{ required:true },
		Status				:	{ required:true },
		LocationLimit		:	{ required:true },
		
		//StaticMessage	    :	{ required:true },
		//DynamicMessage	    :	{ required:true },
		//DynamicMessageFR	:	{ required:true },
		/* Angle1Description	:	{ required:{  
									depends: function(){
										if($("#Angle1").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle1DescriptionFR	:	{ required:{  
									depends: function(){
										if($("#Angle1").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle2Description	:	{ required:{  
									depends: function(){
										if($("#Angle2").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle2DescriptionFR	:	{ required:{  
									depends: function(){
										if($("#Angle2").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle3Description	:	{ required:{  
									depends: function(){
										if($("#Angle3").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle3DescriptionFR	:	{ required:{  
									depends: function(){
										if($("#Angle3").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle4Description	:	{ required:{  
									depends: function(){
										if($("#Angle4").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle4DescriptionFR	:	{ required:{  
									depends: function(){
										if($("#Angle4").val() != '') {	return true; }
										else { return false; }
										}
									}
								},
		Angle1MsgFr			:	{ required:{
									depends: function() {
										if($('#Angle1Msg').val() != '') { return true; }
										else { return false; }
										}
									}
								},
		Angle2MsgFr			:	{ required:{
									depends: function() {
										if($('#Angle2Msg').val() != '') { return true; }
										else { return false; }
										}
									}
								} */
	},
	messages:{
		Organizations		:	{ required:'Organization is required' },
		BeaconType			:	{ required:'Beacon Type is required' },
		Identifier			:	{ identifier_format:'Please enter a valid identifier' },
		uuid         		:	{ required:'UUID is required' },
		Interval			:	{ required:'Interval is required' },
		Major       	    :	{ required:'Major is required' },
		Minor       		:	{ required:'Minor is required' },
		Latitude			:	{ required:'Latitude is required' },
		Longitude			:	{ required:'Longitude is required' },
		//Description			:	{ required:'Beacon Name is required' },
		Description			:	{ required:function(){ 
										if($('#BeaconType').val() == 3)
											return "Intersection Name is required"
										else
											return "Beacon Name is required"
									} 
								},
		DescriptionFR		:	{ required:function(){ 
										if($('#BeaconType').val() == 3)
											return "Intersection Name in french is required"
										else
											return "Beacon Name in french is required"
									} 
								},
		BatteryPower		:	{ battery:'Should not greater than 100'},
		LocationLimit		:	{ required:'Location Limit is required' },
		Status				:	{ required:'Status is required' },
		StreetModVal		:	{ required:'Street 1 Name or Street 2 Name is required' },
		Street1Name			:	{ required:'Street 1 Name is required' },
		Street2Name			:	{ required:'Street 2 Name is required' },
		Street1NameFR		:	{ required:'Street 1 Name in french is required' },
		Street2NameFR		:	{ required:'Street 2 Name in french is required' },
		//StaticMessage	   	:	{ required:'Static message is required' },
		//DynamicMessage	    :	{ required:'Dynamic message is required' },
		//DynamicMessageFR	:	{ required:'Dynamic message in french is required' },
		/* Angle1Description	:	{ required:'Description is required' },
		Angle1DescriptionFR	:	{ required:'Description in french is required' },
		Angle2Description	:	{ required:'Description is required' },
		Angle2DescriptionFR	:	{ required:'Description in french is required' },
		Angle3Description	:	{ required:'Description is required' },
		Angle3DescriptionFR	:	{ required:'Description in french is required' },
		Angle4Description	:	{ required:'Description is required' },
		Angle4DescriptionFR	:	{ required:'Description in french is required' },
		Angle1MsgFr			:	{ required:'Angle 1 Message in french is required' },
		Angle2MsgFr			:	{ required:'Angle 2 Message in french is required' } */
	}
});


//--------------Add user----------------End

//-------------User SignUp---------------------Start
$('#user_signup_form').validate({
	rules:{
		first_name			:	{ required:true },
		//last_name			:	{ required:true },
		email				:	{ required:true,email:true },
		password			:	{ required:true,minlength:6 },
		confirm_password	:	{ required:true,minlength:6,equalTo:'#password' },
		userType			:	{ required:true },
		organization		:	{ required:true }
	},
	messages:{
		first_name			:	{ required:'Name is required' },
		//last_name			:	{ required:'Last Name is required' },
		email				:	{ required:'Email is required',email:'Please enter a valid email address'},
		password			:	{ required:'Password is required',minlength:'Password should have atleast 6 characters'},
		confirm_password	:	{ required:'Confirm Password is required',minlength:'Confirm Password should have atleast 6 characters',equalTo:'Passwords do not match. Please enter the same password in both fields'},
		userType			:	{ required:'User Type is required' },
		organization		:	{ required:'Organization Name is required' }
	}
});
//-------------User Sign Up---------------------End

//-------------User reset password---------------------Start
$("#reset_password_form").validate({
	rules:{
		Password	       :    { required:true,minlength:6},
        C_Password		   :	{ required:true, minlength:6,equalTo:'#Password'}
    },
	messages:{
		Password	       :    { required:'Password is required',minlength:'Password should have atleast 6 characters'},
        C_Password		   :	{ required:'Confirm Password is required',minlength:'Confirm Password should have atleast 6 characters', equalTo:'Password mismatch'},
	}
});
//-------------User reset password---------------------End
$('#edit_customer_form').validate({
	rules:{
		FirstName		:	{ required:true },
		LastName		:	{ required:true },
		Email			:	{ required:true, email:true },
		Status			:	{ required:true },
		Password		:	{ minlength:6 }, //required:true,
		ConfirmPassword	:	{ minlength:6,equalTo:'#Password' } //required:true,
	},
	messages:{
		FirstName		:	{ required:'First Name is required' },
		LastName		:	{ required:'Last Name is required' },
		Email			:	{ required:'Email is required', email:'Please enter valid email id' },
		Status			:	{ required:'Status is required' },
		Password		:	{ minlength:'Password should have atleast 6 characters'}, //required:'Password is required',
		ConfirmPassword	:	{ minlength:'Confirm Password should have atleast 6 characters',equalTo:'Passwords do not match. Please enter the same password in both fields'} //required:'Confirm Password is required',
	}
});

$('#edit_user_form').validate({
	rules:{
		FirstName		:	{ required:true },
		//LastName		:	{ required:true },
		Email			:	{ required:true, email:true },
		Status			:	{ required:true },
		Password		:	{ minlength:6 }, //required:true,
		ConfirmPassword	:	{ minlength:6,equalTo:'#Password' }, //required:true,
		userType		:	{ required:true },
		organization	:	{ required:true }
	},
	messages:{
		FirstName		:	{ required:'Name is required' },
		//LastName		:	{ required:'Last Name is required' },
		Email			:	{ required:'Email is required', email:'Please enter valid email id' },
		Status			:	{ required:'Status is required' },
		Password		:	{ minlength:'Password should have atleast 6 characters'}, //required:'Password is required',
		ConfirmPassword	:	{ minlength:'Confirm Password should have atleast 6 characters',equalTo:'Passwords do not match. Please enter the same password in both fields'}, //required:'Confirm Password is required',
		userType		:	{ required:'User Type is required' },
		organization	:	{ required:'Organization Name is required'}
	}
});
//-----------------User edit form--------------------end

//----------------User type from------------------start
$('#add_user_type_form').validate({
	rules:{
		UserType	:	{ required:true }
	},
	messages:{
		UserType	:	{ required:'User Type is required' }
	}
});
//---------------User type form-----------------------end


$('#add_city_form').validate({
	rules:{
		CityName	:	{ required:true }
	},
	messages:{
		CityName	:	{ required:'City Name is required' }
	}
});	

$('#add_major_form').validate({
	rules:{
		// uuid		:	{ required:true },
		uuid		:	{ required:{
								depends: function() {
									if($('#BeaconType').val() == 1) { return true; }
									else { return false; }
								}
							}
						},
		MajorRange	:	{ required:{
								depends: function() {
									if($('#BeaconType').val() == 3) { return true; }
									else { return false }
								}
							}
						},
		DoorMajor	:	{ required:{
								depends: function() {
									if($('#BeaconType').val() == 4) { return true; }
									else { return false }
								}
							}
						},
		Major		:	{ required:{
								depends: function() {
									if($('#BeaconType').val() == 1) { return true; }
									else { return false; }
								}
							}
						},
		OpenNewMajor:	{ required:{
								depends: function() {
									if($('#DoorMajor').val() == 'new' && $('#BeaconType').val() == 4) { return true; }
									else { return false; }
								}
							},
							non_zero:true
						},
		new_Major	:	{ required:{
								depends: function() {
									if($('#Major_lat').val() == 'new') { return true; }
									else { return false; }
								}
							},
							non_zero:true
						},
		Latitude	:	{ required:true },
		Longitude	:	{ required:true }
	},
	messages:{
		uuid		:	{ required: 'UUID is required' },
		Major		:	{ required: 'Major is required' },
		MajorRange	:	{ required: 'Major is required' },
		DoorMajor	:	{ required: 'Major is required' },
		new_Major	:	{ required: 'Major is required',non_zero:'Please enter valid data' },
		OpenNewMajor:	{ required: 'Major is required',non_zero:'Please enter valid data' },
		Latitude	:	{ required: 'Latitude is required' },
		Longitude	:	{ required: 'Longitude is required' }
	}
});

$('#add_organization_form').validate({
	rules:{
		OrganizationName	:	{ required:true },
		MajorFrom			:	{ required:{  
									depends: function(){
										if($("#IsTraffic").is(':checked')) { return true; }
										else if($('#IsOpenDoor').is(':checked')) { return true; }
										else { return false; }
										}
									}
								},		
		MajorTo				:	{ required:{  
									depends: function(){
										if($("#IsTraffic").is(':checked')) { return true; }
										else if($('#IsOpenDoor').is(':checked')) { return true; }
										else { return false; }
										}
									},
								  greaterThan : "#MajorFrom"
								},
		CityName			:	{ required:{  
									depends: function(){
										if($("#IsTraffic").is(':checked')) { return true; }
										else { return false; }
										}
									}
								}
	},
	messages:{
		OrganizationName	:	{ required:'Organization Name is required' },
		MajorFrom			:	{ required:'Major From is required' },
		MajorTo				:	{ required:'Major To is required',greaterThan: 'Major To is should greater than Major From' },
		CityName			:	{ required:'City Name is required' }
	}
});	

$('#add_subadmins_form').validate({
	rules : {
		UserName			:	{ required:true,no_space:true },
		Email				:	{ required:true,email:true },
		Password			:	{ required:true,minlength:6},
		ConfirmPassword		:	{ required:true,minlength:6,equalTo:'#Password'},
		Organizations		:	{ required:true }
	},
	messages : {
		UserName			:	{ required: 'User Name is required',no_space:'Please enter valid user name' },
		Email				:	{ required: 'Email Address is required' },
		Password			:	{ required: 'Password is required', minlength: 'Password should have atleast 6 characters'},
		ConfirmPassword		:	{ required: 'Confirm Password is required', minlength: 'Confirm Password should have atleast 6 characters', equalTo : 'Passwords do not match. Please enter the same password in both fields'},
		Organizations		:	{ required: 'Organizations is required' }
	}
});

$('#edit_subadmins_form').validate({
	rules : {
		UserName			:	{ required:true },
		Email				:	{ required:true,email:true },
		Password			:	{ minlength:6},
		ConfirmPassword		:	{ minlength:6,equalTo:'#Password'},
		Organizations		:	{ required:true }
	},
	messages : {
		UserName			:	{ required: 'User Name is required' },
		Email				:	{ required: 'Email Address is required' },
		Password			:	{ minlength: 'Password should have atleast 6 characters'},
		ConfirmPassword		:	{ minlength: 'Confirm Password should have atleast 6 characters', equalTo : 'Passwords do not match. Please enter the same password in both fields'},
		Organizations		:	{ required: 'Organizations is required' }
	}
});

});